"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "observe", {
  enumerable: true,
  get: function get() {
    return _observerUtil.observe;
  }
});
Object.defineProperty(exports, "unobserve", {
  enumerable: true,
  get: function get() {
    return _observerUtil.unobserve;
  }
});
exports.Component = exports.sharedComponentData = void 0;

var _react = require("react");

var _observerUtil = require("@nx-js/observer-util");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var testEnv = (typeof process === "undefined" ? "undefined" : _typeof(process)) == 'object' && process != null && _typeof(process.env) == 'object' && process.env != null && process.env.NODE_ENV == 'test';
var bindComponentExcludes = ['constructor', 'render', // 'componentDidMount', must be bound in case this function is called in a component method
'shouldComponentUpdate', 'getSnapshotBeforeUpdate', 'componentDidUpdate', // 'componentWillUnmount', must be bound in case this function is called in a component method
'componentDidCatch', // 'mounted', must be bound in case this function is called in a component method
'updated' // 'beforeUnmount' must be bound in case this function is called in a component method
];
var bindInstanceExcludes = ['constructor', '__defineGetter__', '__defineSetter__', 'hasOwnProperty', '__lookupGetter__', '__lookupSetter__', 'isPrototypeOf', 'propertyIsEnumerable', 'toString', 'valueOf', '__proto__', 'toLocaleString'];
var observableExcludes = ['props', 'context', 'refs', 'updater', 'state'];

var sharedComponentData = function sharedComponentData(object) {
  var shared = (0, _observerUtil.observable)(object); // Do not allow use of asynchronous operations in constructor, since changes to member variables will not be observed

  var constructorStr = object.constructor.toString();
  var idx = constructorStr.indexOf('\n');

  if (idx != -1) {
    idx += 1;

    while (constructorStr[idx] == ' ') {
      idx += 1;
    }

    if (constructorStr.startsWith('var _this', idx)) throw new Error('Detected use of asynchronous operation in constructor. Use a separate function for such operations that you call after the sharedComponentData object has been made.');
  } // Bind methods


  var _iterator = _createForOfIteratorHelper(Object.getOwnPropertyNames(Object.getPrototypeOf(object))),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var name = _step.value;
      if (!bindInstanceExcludes.includes(name)) shared[name] = shared[name].bind(shared);
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  return shared;
};

exports.sharedComponentData = sharedComponentData;

// The same observable must be used elsewhere or else components will not rerender
var Component = /*#__PURE__*/function (_ReactComponent) {
  _inherits(Component, _ReactComponent);

  var _super = _createSuper(Component);

  _createClass(Component, null, [{
    key: "instance",
    // Returns the last instance
    value: function instance() {
      if (!Component._instances) return null;

      var instances = Component._instances.get(this.name);

      if (!instances || instances.length == 0) return null;
      return instances[instances.length - 1];
    }
  }, {
    key: "instances",
    value: function instances() {
      if (!Component._instances) return [];

      var instances = Component._instances.get(this.name);

      if (!instances) return [];
      return instances;
    }
  }]);

  function Component() {
    var _this;

    _classCallCheck(this, Component);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    if (!Component._instances) Component._instances = new Map();

    var instances = Component._instances.get(_this.constructor.name);

    if (!instances) Component._instances.set(_this.constructor.name, [_assertThisInitialized(_this)]);else instances.push(_assertThisInitialized(_this)); // Bind methods

    var _iterator2 = _createForOfIteratorHelper(Object.getOwnPropertyNames(Object.getPrototypeOf(_assertThisInitialized(_this)))),
        _step2;

    try {
      for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
        var name = _step2.value;

        if (!name.startsWith('UNSAFE_component') && !bindComponentExcludes.includes(name)) {
          _this[name] = _this[name].bind(_assertThisInitialized(_this));
        }
      } // Create getters and setters for properties. Objects are made observable.

    } catch (err) {
      _iterator2.e(err);
    } finally {
      _iterator2.f();
    }

    var render = _this.render;
    var variables = new Map();
    var rerenderVariables = new Set();

    if (testEnv) {
      _this._reactSimplifiedVariables = variables;
      _this._reactSimplifiedRerenderVariables = rerenderVariables;
    }

    var firstRenderCall = true;
    var duringRenderCall = false;

    _this.render = function () {
      if (firstRenderCall) {
        firstRenderCall = false;
        var ownPropertyNames = Object.getOwnPropertyNames(_assertThisInitialized(_this));

        var _iterator3 = _createForOfIteratorHelper(ownPropertyNames),
            _step3;

        try {
          var _loop = function _loop() {
            var name = _step3.value;

            var type = _typeof(_this[name]);

            if (type != 'function' && !name.startsWith('_react') && !observableExcludes.includes(name)) {
              if (type == 'undefined') {
                throw new Error('Detected undefined member variable ' + name + ' in class ' + _this.constructor.name + '. Since such variables are unsafe to use in render(), you must initialize this variable.');
              }

              if (type == 'object' && _this[name] != null) {
                // Do not make React.createRef() objects observable
                if (Object.isSealed(_this[name])) {
                  var keys = Object.keys(_this[name]);
                  if (keys.length == 1 && keys[0] == 'current') return "continue";
                }

                variables.set(name, (0, _observerUtil.observable)(_this[name]));
              } else {
                variables.set(name, _this[name]);
              }

              Object.defineProperty(_assertThisInitialized(_this), name, {
                get: function get() {
                  if (duringRenderCall) rerenderVariables.add(name);
                  return variables.get(name);
                },
                set: function set(value) {
                  var rerender = rerenderVariables.has(name);
                  variables.set(name, _typeof(value) == 'object' && value != null && rerender ? (0, _observerUtil.observable)(value) : value);
                  if (rerender) _this.setState({});
                }
              });
            }
          };

          for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
            var _ret = _loop();

            if (_ret === "continue") continue;
          }
        } catch (err) {
          _iterator3.e(err);
        } finally {
          _iterator3.f();
        }
      }

      duringRenderCall = true;
      var result = render.call(_assertThisInitialized(_this));
      duringRenderCall = false;
      return result;
    }; // Schedule rerender when observable objects change


    _this.render = (0, _observerUtil.observe)(_this.render, {
      scheduler: function scheduler() {
        return _this.setState({});
      },
      lazy: true
    });
    var componentDidMount; // Storage for this.componentDidMount

    var rootNode; // Stores used prop keys in a tree for fast traversal. A node is a map of child key to child node.

    if (_this.mounted || _this.componentDidMount) {
      componentDidMount = _this.componentDidMount;

      _this.componentDidMount = function () {
        var parentPropToParentNode = new Map(); // References to parent nodes containing used prop keys

        var propToProxy = new Map();
        var handlers = {
          get: function get(target, key, receiver) {
            var result = Reflect.get(target, key, receiver); // See https://stackoverflow.com/a/39003741

            var parentNode = parentPropToParentNode.get(target);

            if (!parentNode.has(key)) {
              var node = new Map();
              parentNode.set(key, node);
              parentPropToParentNode.set(result, node);
            }

            if (_typeof(result) == 'object' && result != null) {
              // If proxy is already created, return it instead of making a new proxy
              var proxy = propToProxy.get(result);
              if (proxy) return proxy;
              proxy = new Proxy(result, handlers);
              propToProxy.set(result, proxy);
              return proxy;
            }

            return result;
          }
        };
        var storedProps = _this.props;
        var mutableProps = Object.assign({}, _this.props); // Only shallow copy needed since freeze and seal are shallow

        rootNode = new Map();
        parentPropToParentNode.set(mutableProps, rootNode);
        _this.props = new Proxy(mutableProps, handlers);
        var result;
        if (_this.mounted) result = _this.mounted();else if (componentDidMount) result = componentDidMount();
        _this.props = storedProps;
        return result;
      };
    } // Disable rerender when component is about to be unmounted


    var componentWillUnmount = _this.componentWillUnmount;

    _this.componentWillUnmount = function () {
      var instances = Component._instances.get(_this.constructor.name);

      instances.splice(instances.indexOf(_assertThisInitialized(_this)), 1);
      (0, _observerUtil.unobserve)(_this.render);
      if (_this.beforeUnmount) return _this.beforeUnmount();
      if (componentWillUnmount) return componentWillUnmount();
    }; // Calls componentWillUnmount and componentDidMount when props that are used in componentDidMount changes


    var componentDidUpdate = _this.componentDidUpdate;

    _this.componentDidUpdate = function (prevProps, prevState, snapshot) {
      if (!_this.updated && // This method might already handle calling componentWillUnmount or componentDidMount
      !componentDidUpdate && // This method might already handle calling componentWillUnmount or componentDidMount
      _this.componentDidMount && _this.props != prevProps) {
        var equal = function equal(prevProps, props, parentNode) {
          var _iterator4 = _createForOfIteratorHelper(parentNode),
              _step4;

          try {
            for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
              var _step4$value = _slicedToArray(_step4.value, 2),
                  key = _step4$value[0],
                  node = _step4$value[1];

              var prevValue = prevProps[key];
              var value = props[key];
              if (_typeof(prevValue) == 'object' && _typeof(value) == 'object' ? prevValue != null && value == null || prevValue == null && value != null : prevValue !== value) return false;
              if (!equal(prevProps[key], props[key], node)) return false;
            }
          } catch (err) {
            _iterator4.e(err);
          } finally {
            _iterator4.f();
          }

          return true;
        };

        if (!equal(prevProps, _this.props, rootNode)) {
          if (_this.beforeUnmount) _this.beforeUnmount();else if (componentWillUnmount) componentWillUnmount();

          _this.componentDidMount();
        }
      }

      if (_this.updated) return _this.updated(prevProps, prevState, snapshot);
      if (componentDidUpdate) return componentDidUpdate.call(_assertThisInitialized(_this), prevProps, prevState, snapshot);
    };

    return _this;
  }

  return Component;
}(_react.Component);

exports.Component = Component;